
package com.redxun.certificate.core.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.redxun.certificate.core.entity.Certificate;
import com.redxun.certificate.core.mapper.CertificateMapper;
import com.redxun.common.base.db.BaseDao;
import com.redxun.common.base.db.BaseService;
import com.redxun.common.base.db.PageHelper;
import com.redxun.common.base.search.QueryFilter;
import com.redxun.common.service.impl.SuperServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Map;

/**
 * [证书]业务服务类
 */
@Service
public class CertificateServiceImpl extends SuperServiceImpl<CertificateMapper, Certificate> implements BaseService<Certificate> {

    @Resource
    private CertificateMapper certificateMapper;

    @Override
    public BaseDao<Certificate> getRepository() {
        return certificateMapper;
    }

    public IPage selectCertificateAll(QueryFilter filter) {
        Map<String, Object> params = PageHelper.constructParams(filter);
        return certificateMapper.selectCertificateAll(filter.getPage(), params);
    }

    public IPage selectUserCertificate(QueryFilter filter) {
        Map<String, Object> params = PageHelper.constructParams(filter);
        return certificateMapper.selectUserCertificate(filter.getPage(), params);
    }

    public IPage selectValidCertificate(QueryFilter filter) {
        Map<String, Object> params = PageHelper.constructParams(filter);
        return certificateMapper.selectValidCertificate(filter.getPage(), params);
    }
}
