
/**
 * <pre>
 *
 * 描述：demo实体类定义
 * 表:demo
 * 作者：ray
 * 邮箱: ray@redxun.cn
 * 日期:2021-05-20 14:18:28
 * 版权：广州红迅软件
 * </pre>
 */
package com.redxun.demo.core.entity;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.redxun.common.base.entity.BaseExtEntity;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;
import org.apache.ibatis.type.JdbcType;

@Setter
@Getter
@Accessors(chain = true)
@TableName(value = "demo")
public class Demo extends BaseExtEntity<String> {

    @JsonCreator
    public Demo() {
    }

    //主键
    @TableId(value = "ID_",type = IdType.INPUT)
    private String id;

    //姓名
    @TableField(value = "NAME_",jdbcType=JdbcType.VARCHAR)
    private String name;

    //出生日期
    @TableField(value = "BIRTHDAY_",jdbcType=JdbcType.DATE)
    @JSONField(
            format = "yyyy-MM-dd"
    )
    @JsonFormat(
            pattern = "yyyy-MM-dd",
            timezone = "GMT+8"
    )
    private java.util.Date birthday;


    @Override
    public String getPkId() {
        return id;
    }

    @Override
    public void setPkId(String pkId) {
        this.id=pkId;
    }



}



